/* SEND_C30.H - INCLUDE FILE FOR sendout, getinput and C30/C31 */

void main(void);
void c_int05(void);
void init_arrays(void);
void wait_buffer(void);
void command_process(void);

/* GLOBAL VARIABLES */
int *output;                   /* POINTER TO OUTPUT DATA ARRAY            */
int *input;                    /* POINTER TO INPUT DATA ARRAY             */
volatile int index = 0;        /* INDEX INTO INPUT AND OUTPUT DATA ARRAYS */
volatile int in_inx = 0;
volatile int out_inx = 0;
volatile int int_flag = 0;     /* interupt enable flag */

/* AIC CONTROL VARIABLES */
extern AIC_COMMAND_0  aic_command_0;     /* AIC COMMAND WORD 0 */
extern AIC_COMMAND_1  aic_command_1;     /* AIC COMMAND WORD 1 */
extern AIC_COMMAND_2  aic_command_2;     /* AIC COMMAND WORD 2 */
extern AIC_COMMAND_3  aic_command_3;     /* AIC COMMAND WORD 3 */
extern volatile int send_command ;       /* FLAG TO SEND AIC COMMAND WORD */
extern volatile int secondary_transmit;  /* FLAG TO SEND SECONDARY TRANSMIT*/
extern int aic_secondary;         /* COMMAND TO SEND ON SECONDARY TRANSMIT*/

/* SERIAL PORT BASE LOCATION */
extern volatile int (*serial_port)[16];

/* DMA BASE LOCATION */
extern volatile int *dma;

#define BLOCK_SIZE     2000      /* BLOCK SIZE FOR I/O */
