#include <math.h>

/* COMPLEX STRUCTURE */

typedef struct {
    float real, imag;
} COMPLEX;

void fft_c(int n, COMPLEX *x, COMPLEX *w);
void init_w(int n, COMPLEX *w);

#define PI 3.14159265358979323846
int n = 1024;
COMPLEX x[1024],w[1024];
void main()
{
    int i;

    init_w(n,w);

    x[0].real = 1.0;
    fft_c(n,x,w);
/* print the first few outputs */
    for(i = 0 ; i < 20 ; i++) {
        printf("\n%3d %12.5f %12.5f",i,x[i].real,x[i].imag);
    }
}

void fft_c(int n,COMPLEX *x,COMPLEX *w)
{
    COMPLEX u,temp,tm;
    COMPLEX *xi,*xip,*wptr;

    int i,j,le,windex;

/* start fft */

    windex = 1;
    for(le=n/2 ; le > 0 ; le/=2) {
        wptr = w;
        for (j = 0 ; j < le ; j++) {
            u = *wptr;
            for (i = j ; i < n ; i = i + 2*le) {
                xi = x + i;
                xip = xi + le;
                temp.real = xi->real + xip->real;
                temp.imag = xi->imag + xip->imag;
                tm.real = xi->real - xip->real;
                tm.imag = xi->imag - xip->imag;             
                xip->real = tm.real*u.real - tm.imag*u.imag;
                xip->imag = tm.real*u.imag + tm.imag*u.real;
                *xi = temp;
            }
            wptr = wptr + windex;
        }
        windex = 2*windex;
    }            
}
void init_w(int n, COMPLEX *w)
{
    int i;
    float a = 2.0*PI/n;
    for(i = 0 ; i < n ; i++) {
        w[i].real = cos(i*a);
        w[i].imag = sin(i*a);
    }
}
