#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <math.h>
#include "rtdspc.h"
#include "filter.h"

/***********************************************************************

MKGWN.C - Gaussian Noise Filter Example

This program filters a sine wave with added Gaussian noise.  It
implements a 35 point FIR filter (stored in variable fir_lpf35)
on an generated signal.  The filter is a LPF with 40 dB out of
band rejection.  The 3 dB point is at a relative frequency of
approximately .25*fs.

************************************************************************/

float sigma = 0.2;

void main()
{
  int          i, j;
  float x;
  static float hist[34];
/* first with filter */
  for(i = 0 ; i < 6000 ; i++) {
      x = sin(0.05*2*PI*i) + sigma*gaussian();
      x *= 25000.0;         /* scale for D/A converter */
      sendout(fir_filter(x,fir_lpf35,35,hist));
  }
/* now without filter */
  for(i = 0 ; i < 6000 ; i++) {
      x = sin(0.05*2*PI*i) + sigma*gaussian();
      x *= 25000.0;         /* scale for D/A converter */
      sendout(x);
  }
  flush();
}
